// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_comm_functions_hpp
#define anna_comm_functions_hpp

#include <vector>

#include <anna/app/functions.hpp>

namespace anna {

namespace comm {

class Application;
class Server;
class Service;

/**
   functions - Methods and variables
*/
struct functions : public anna::app::functions {
  /**
     Returns the host name over which we are executing our process.
     @return host name over which we are executing our process.
  */
  static std::string getHostName() throw(RuntimeException);


  /**
     Resolves the host name provided with the first IP returned by the system.
     Aliases and their addresses are traced as well as the official host name.

     @param hostname Logical name for the server used to resolve (could be www.gopher.net i.e.).

     @return First IP address returned by the system.

     \see man gethostbyname.
   */
  static std::string resolveIP(const char* hostname) throw(RuntimeException);

  /**
     Returns our application instance on anna.comm layer.
     @return Reference to our application instance on anna.comm layer.
  */
  static comm::Application& getApp() throw(RuntimeException);
};

}
}

#endif


