// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_comm_handler_DatagramSocket_hpp
#define anna_comm_handler_DatagramSocket_hpp

#include <anna/comm/handler/MetaClientSocket.hpp>

#include <anna/comm/handler/Allocator.hpp>

namespace anna {

namespace comm {

class DatagramSocket;

namespace handler {

class DatagramSocket : public MetaClientSocket {
public:
  DatagramSocket(Communicator* communicator) :
    MetaClientSocket(communicator, Handler::Type::DatagramSocket),
    a_datagramSocket(NULL)
  {;}

  void setup(comm::DatagramSocket* datagramSocket) throw() { a_datagramSocket = datagramSocket; }

  comm::ClientSocket* getClientSocket() throw();

private:
  comm::DatagramSocket* a_datagramSocket;

  void initialize() throw(RuntimeException);
  void apply() throw(RuntimeException);
  void finalize() throw();

  std::string asString() const throw();
  xml::Node* asXML(xml::Node*) const throw();
};

}
}
}

#endif

