// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_diameter_codec_basetypes_Float32_hpp
#define anna_diameter_codec_basetypes_Float32_hpp


// Local
#include <anna/diameter/codec/basetypes/AvpData.hpp>

#include <anna/config/defines.hpp>

#include <anna/comm/functions.hpp>

namespace anna {

namespace diameter {

namespace codec {

class Avp;

namespace basetypes {

/**
* Diameter Float32 container
*/
class Float32 : public AvpData {

  F32 a_value;


  // Mandatory for basic diameter type:
  void codeBasic(char* buffer, int &size) throw(anna::RuntimeException);
  void setPrintableString(const char * printableString) throw(anna::RuntimeException);

public:

  virtual ~Float32() {;}

  // Class-specific ////////////////////////////////////////////////////////////////////////////////////
  //
  /**
  * Gets the Float32 value
  *
  * @return Float32 value
  */
  const F32& getValue() const throw() { return a_value; }

  /**
  * Sets the Float32 value
  *
  * @param value Float32 value
  */
  void setValue(const F32& value) throw() { a_value = value; }
  //
  //////////////////////////////////////////////////////////////////////////////////////////////////////


  // gets

  virtual std::string getFormatName() const throw() { return "Float32"; }
  virtual int getSize() const throw() { return 4; }


  // helpers

  std::string asPrintableString() throw(anna::RuntimeException) {
    return anna::functions::asString(a_value);
  }

  std::string asString() throw(anna::RuntimeException) {
    return asPrintableString();
  }


  // sets

  void decode(const char* buffer, const int size) throw(anna::RuntimeException);
};

}
}
}
}

#endif
