// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


// Local
#include <anna/diameter/stack/Vendor.hpp>

#include <anna/core/functions.hpp>
#include <anna/xml/xml.hpp>

//using namespace anna;

anna_assign_enum(anna::diameter::stack::Vendor::Code) = { "Ietf", "Nokia", "Ericsson", "3GPP", "Telefonicaid", "Etsi", NULL /* list end indicator */};

//------------------------------------------------------------------------------
//----------------------------------------------------------- Vendor::asString()
//------------------------------------------------------------------------------
std::string anna::diameter::stack::Vendor::asString(void) const throw() {
  std::string trace;
  //trace = "Vendor '";
  trace = "'";
  trace += a_name;
  trace += "'(";
  trace += anna::functions::asString(a_id);
  trace += ")";
  return (trace);
}


//------------------------------------------------------------------------------
//-------------------------------------------------------------- Vendor::asXML()
//------------------------------------------------------------------------------
anna::xml::Node* anna::diameter::stack::Vendor::asXML(anna::xml::Node* parent) const throw() {
//   <!ELEMENT vendor EMPTY>
//   <!ATTLIST vendor name CDATA #REQUIRED code CDATA #REQUIRED>
  anna::xml::Node* result = parent->createChild("vendor");
  result->createAttribute("name", a_name);
  result->createAttribute("code", anna::functions::asString(a_id));
  return result;
}

