#!/bin/bash

_exit() {
   echo
   echo $1
   echo
   exit
}

_print() {
   result=
   must=-
   may=-
   shouldnot=-
   mustnot=-
   enc=-
   [[ "$V" = "must" ]] && must="$must,V"
   [[ "$M" = "must" ]] && must="$must,M"
   [[ "$P" = "must" ]] && must="$must,P"
   [[ "$V" = "may" ]] && may="$may,V"
   [[ "$M" = "may" ]] && may="$may,M"
   [[ "$P" = "may" ]] && may="$may,P"
   [[ "$V" = "shouldnot" ]] && shouldnot="$shouldnot,V"
   [[ "$M" = "shouldnot" ]] && shouldnot="$shouldnot,M"
   [[ "$P" = "shouldnot" ]] && shouldnot="$shouldnot,P"
   [[ "$V" = "mustnot" ]] && mustnot="$mustnot,V"
   [[ "$M" = "mustnot" ]] && mustnot="$mustnot,M"
   [[ "$P" = "mustnot" ]] && mustnot="$mustnot,P"
   [[ "$ENC" = "yes" ]] && enc="$enc,Y"
   [[ "$ENC" = "no" ]] && enc="$enc,N"

   _must=$(echo $must | cut -d',' -f2-)
   _may=$(echo $may | cut -d',' -f2-)
   _shouldnot=$(echo $shouldnot | cut -d',' -f2-)
   _mustnot=$(echo $mustnot | cut -d',' -f2-)
   _enc=$(echo $enc | cut -d',' -f2-)

   printf "%50s %2s %10s %2s %10s %2s %10s %2s %10s %2s %10s\n" $AVP "|" $_must "|" $_may "|" $_shouldnot "|" $_mustnot "|" $_enc
}


[[ "$1" = "" ]] && _exit "Use: $0 <avps dictionary>, i.e.: $0 avps_ietf.xml"
FILE=$1
BN_FILE=`basename $FILE`
TMP_FILE=.${BN_FILE}.tmp

grep "<avp name=" $FILE > $TMP_FILE

printf "%50s %2s %10s %2s %10s %2s %10s %2s %10s %2s %10s\n" AVP "|" Must "|" May "|" "Should Not" "|" "Must Not" "|" "May Encrypt"
echo "-------------------------------------------------------------------------------------------------------------------------"

while read -r line
do
   AVP=$(echo $line | awk -F'avp name=' '{ print $2 }' | cut -d'"' -f2)
   V=$(echo $line | awk -F'v-bit=' '{ print $2 }' | cut -d'"' -f2)
   M=$(echo $line | awk -F'm-bit=' '{ print $2 }' | cut -d'"' -f2)
   P=$(echo $line | awk -F'p-bit=' '{ print $2 }' | cut -d'"' -f2)
   ENC=$(echo $line | awk -F'may-encrypt=' '{ print $2 }' | cut -d'"' -f2)

   _print

done < $TMP_FILE



rm $TMP_FILE
